/*****************************************************************************
* Chuong trinh C2-3: Chuong trinh dinh tri mot bieu thuc postfix. Chuong     *
* trinh co cai dat stack de chua cac toan hang (operands), moi toan hang la  *
* mot ky so. Co 5 toan tu la cong (+), tru (-), nhan (*), chia (/) va luy    *
* thua ($)                                                                   *
*   Vi du:        23+     =   5.00                                           *
*		            23*     =   6.00                                           *
*		            23+4*5/ =   4.00                                           *
*		            23+3$   =   125.00                                         *
* Nguoi viet chuong trinh: Nguyen Hong Chuong                                *
* Ngay cap nhat moi nhat: 15/3/1999                                          *
*****************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <math.h>

#define TOIDA 80
#define TRUE 1
#define FALSE 0

// Khai bao stack chua cac toan hang
struct stack
{
   int top;
   double nodes[TOIDA];
};

// prototypes
int empty(struct stack *);
void push(struct stack *, double);
double pop(struct stack *);

double dinhtri(char[]);
int lakyso(char);
double tinh(int, double, double);

int empty(struct stack *ps)
{
   if (ps->top == -1)
      return(TRUE);
   else
      return(FALSE);
}

void push(struct stack *ps, double x)
{
   if(ps->top == TOIDA-1)
      printf("%s", "stack bi day");
   else
      ps->nodes[++(ps->top)] = x;
}

double pop(struct stack *ps)
{
   if(empty(ps))
      printf("%", "stack bi rong");
   else
      return(ps->nodes[ps->top--]);
}

// Ham dinhtri: tinh mot bieu thuc postfix
double dinhtri(char bieuthuc[])
{
   int c, vitri;
   double toanhang1, toanhang2, tri;
   struct stack s;

   s.top = -1;  // khoi dong stack

   for(vitri = 0; (c = bieuthuc[vitri]) != '\0'; vitri++)
      if(lakyso(c))  // c la toan hang
	      push(&s, (double)(c-'0'));
      else           // c la toan tu
      {
	      toanhang2 = pop(&s);
	      toanhang1 = pop(&s);
	      tri = tinh(c, toanhang1, toanhang2);  // tinh ket qua trung gian
	      push(&s, tri);
      }
   return(pop(&s));
}

// Ham lakyso: kiem tra mot ky tu co phai la ky so hay khong
int lakyso(char kytu)
{
   return(kytu >= '0' && kytu <= '9');
}

/* Ham tinh: tinh tri cua hai toan hang toanhang1 va toanhang2 qua
   phep toan toantu                                                         */
double tinh(int toantu, double toanhang1, double toanhang2)
{
   switch(toantu)
   {
      case '+':
         return(toanhang1 + toanhang2);
      case '-':
	      return(toanhang1 - toanhang2);
      case '*':
	      return(toanhang1 * toanhang2);
      case '/':
	      return(toanhang1 / toanhang2);
      case '$':
	      return(pow(toanhang1, toanhang2));
      default:
	      printf("%s", "toan tu khong hop le");
	      exit(1);
   }
}

void main()
{
   char c, bieuthuc[TOIDA];
   int vitri;

   clrscr();

   do
   {
      vitri = 0;
      printf("\n\nNhap bieu thuc postfix can dinh tri: ");
      while ((bieuthuc[vitri++] = getchar()) != '\n')
	      ;
      bieuthuc[--vitri] = '\0';
      printf("%s%s%s%5.2f", "Bieu thuc ", bieuthuc, " co tri la: ",
	                                       dinhtri(bieuthuc));
      printf("\n\nTiep tuc khong ? (c/k): ");
      c = getche();
   } while(c == 'c' || c == 'C');
}
