/*****************************************************************************
* Chuong trinh C3-1: Chuong trinh quan ly kho                                *
*                    mat hang nao nhap kho truoc se duoc xuat kho truoc      *
* Nguoi viet chuong trinh: Nguyen Hong Chuong                                *
* Ngay cap nhat moi nhat: 15/3/1999                                          *
*****************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <conio.h>

#define MAXQUEUE 100
#define TRUE 1
#define FALSE 0

// Khai bao cau truc mathang
typedef struct mathang
{
   int mamh;
   char tenmh[12];
};

struct queue
{
   int front, rear;
   mathang nodes[MAXQUEUE];
};

void initialize(struct queue *pq)
{
   pq->front = pq->rear = MAXQUEUE-1;
}

int empty(struct queue *pq)
{
   return((pq->front == pq->rear) ? TRUE : FALSE);
}

void insert(struct queue *pq, mathang x)
{
   if(pq->rear == MAXQUEUE-1)
      pq->rear = 0;
   else
      (pq->rear)++;
   if(pq->rear == pq->front)
      printf("kho hang bi day");
   else
      pq->nodes[pq->rear] = x;
}

mathang remove(struct queue *pq)
{
   if(empty(pq))
      printf("kho khong con hang");
   else
   {
      if(pq->front == MAXQUEUE-1)
         pq->front = 0;
      else
         (pq->front)++;
      return(pq->nodes[pq->front]);
   }
}

// Tac vu traverse: duyet kho hang tu front toi rear
void traverse(struct queue *pq)
{
   int i;
   if(empty(pq))
   {
		printf("\nKho khong con hang");
      return;
   }
   if(pq->front == MAXQUEUE-1)
      i = 0;
   else
      i = pq->front+1;
	// vong lap in cac nut tu front den nut ke cuoi
   while(i != pq->rear)
   {
		printf("\n%11d%15s", pq->nodes[i].mamh, pq->nodes[i].tenmh);
		if(i == MAXQUEUE-1)
			i = 0;
		else
			i++;
	}
	// in nut cuoi (nut tai rear)
	printf("\n%11d%15s", pq->nodes[i].mamh, pq->nodes[i].tenmh);
}

// chuong trinh chinh
void main(void)
{
   struct queue q;
   int chucnang, front1;
   char c;
   mathang mh;

   clrscr();

   // khoi tao queue
   initialize(&q);

   do
   {
      printf("\n\n\t\t\tCHUONG TRINH QUAN LY KHO");
      printf("\n\t\t\t(NHAP TRUOC - XUAT TRUOC)");
      printf("\n\nCac chuc nang cua chuong trinh:\n");
      printf("   1: Nhap mot mat hang\n");
      printf("   2: Xuat mot mat hang\n");
		printf("   3: Xem mat hang chuan bi xuat\n");
		printf("   4: Xem mat hang moi nhap\n");
      printf("   5: Xem cac mat hang co trong kho\n");
		printf("   6: Xuat toan bo kho hang\n");
      printf("   0: Ket thuc chuong trinh\n");
      printf("Chuc nang ban chon: ");
      scanf("%d", &chucnang);
      switch(chucnang)
      {
	      case 1:
	      {
	         printf("\nMa mat hang: ");
	         scanf("%d", &mh.mamh);
	         printf("Ten mat hang: ");
	         scanf("%s", &mh.tenmh);
	         insert(&q, mh);
	         break;
	      }
	      case 2:
	      {
            if(!empty(&q))
            {
	            mh = remove(&q);
	            printf("\nMat hang xuat:  Ma:%d  Ten:%s", mh.mamh, mh.tenmh);
            }
            else
               printf("\nKho khong con hang");
	         break;
	      }
			case 3:
			{
				front1 = (q.front == MAXQUEUE-1 ? 0 : q.front+1);
				printf("\nMat hang chuan bi xuat:  Ma:%d  Ten:%s",
                   q.nodes[front1].mamh, q.nodes[front1].tenmh);
				break;
			}
			case 4:
			{
				printf("\nMat hang moi nhap:  Ma:%d  Ten:%s",
                   q.nodes[q.rear].mamh, q.nodes[q.rear].tenmh);
				break;
			}
			case 5:
			{
	         printf("\nCac mat hang co trong kho:");
	         printf("\n%11s%15s", "MA MAT HANG", "   TEN MAT HANG");
				traverse(&q);
				break;
			}
         case 6:  // xoa toan bo queue (khoi dong queue)
			{
				printf("\nBan co chac khong (c/k): ");
				c = getche();
				if(c == 'c' || c == 'C')
					initialize(&q);
				break;
			}
      }
   } while(chucnang != 0);
}