/*****************************************************************************
* Chuong trinh C5-3: Chuong trinh quan ly va dieu hanh tuyen xe lua          *
*                    Chuong trinh cai dat danh sach lien ket kep, moi nut    *
*                    cua danh sach duoc cap phat bang mot bien dong          *
* Nguoi viet chuong trinh: Nguyen Hong Chuong                                *
* Ngay cap nhat moi nhat: 15/3/1999                                          *
*****************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <string.h>
#include <alloc.h>

#define TRUE 1
#define FALSE 0

// Khai bao cau truc cua mot doan xe lua
typedef struct doan
{
   char gatruoc[12];
   char gasau[12];
   int chieudai;   // km
   int thoigian;   // thoi gian xe lua chay tren doan, tinh theo gio
};

// Khai bao cau truc cua mot nut
struct node
{
   doan info;
   struct node *left, *right;
};
typedef struct node *NODEPTR;

// Tac vu getnode: cap phat mot nut cho danh sach lien ket kep
NODEPTR getnode(void)
{
   NODEPTR p;
   p = (NODEPTR)malloc(sizeof(struct node));
   return(p);
}

// Tac vu freenode: huy nut da cap phat
void freenode(NODEPTR p)
{
   free(p);
}

// Tac vu initialize: khoi dong danh sach lien ket kep
void initialize(NODEPTR *plist)
{
   *plist = NULL;
}

// Tac vu empty: kiem tra danh sach lien ket kep co bi rong khong
int empty(NODEPTR *plist)
{
   return((*plist == NULL) ? TRUE : FALSE);
}

// Tac vu listsize: xac dinh so nut co trong danh sach lien ket kep
int listsize(NODEPTR *plist)
{
   NODEPTR p;
   int n;
   p = *plist;  // p chi nut dau
   n = 0;
   while(p != NULL)
   {
      p = p->right;
      n++;
   }
   return(n);
}

/* Tac vu nodepointer: xac dinh con tro chi nut thu i (i=0,1,2,...) trong
   danh sach lien ket kep */
NODEPTR nodepointer(NODEPTR *plist, int i)
{
   NODEPTR p;
   int vitri;
   p = *plist;      // p chi nut dau dslk vong
   vitri = 0;
   while(p != NULL && vitri < i)
   {
      p = p->right;
      vitri++;
   }
   return(p);
}

// Tac vu position: xac dinh vi tri cua nut p trong danh sach lien ket kep
int position(NODEPTR *plist, NODEPTR p)
{
	int vitri;
   NODEPTR q;
	q = *plist;
	vitri = 0;
	while(q != NULL && q != p)
	{
		q = q->right;
		vitri++;
	}
   if(q == NULL)
      return(-1);
	return(vitri);
}

// Tac vu push: them nut vao dau danh sach lien ket
void push(NODEPTR *plist, doan x)
{
   NODEPTR p;
   p = getnode();
   p->info = x;
   if(*plist == NULL)  // truong hop danh sach rong
   {
      p->left = NULL;
      p->right = NULL;
      *plist = p;
   }
   else
   {
      // tao lien ket giua p va plist
      p->right = *plist;
      (*plist)->left = p;

      p->left = NULL;
      *plist = p;
   }
}

// Tac vu insertright: them nut moi sau nut p
void insertright(NODEPTR p, doan x)
{
   NODEPTR q, r;  // q la nut can them vao, p la nut truoc, r la nut sau
   if(p == NULL)
      printf("Nut p khong hien huu, khong them nut duoc\n");
   else
   {
      q = getnode();
      q->info = x;
      r = p->right;
      // tao hai lien ket giua r va q
      r->left = q;
      q->right = r;
      // tao hai lien ket giua p va q
      q->left = p;
      p->right = q;
   }
}

// Tac vu insertleft: them nut moi truoc nut p
void insertleft(NODEPTR *plist, NODEPTR p, doan x)
{
   NODEPTR q, r;  // q la nut can them vao, p la nut sau, r la nut truoc
   if(p == NULL)
      printf("Nut p khong hien huu, khong them nut duoc\n");
   else
   {
      if(p == *plist)  // them nut vao dau danh sach
         push(plist, x);
      else
      {
         q = getnode();
         q->info = x;
         r = p->left;
         // tao hai lien ket giua r va q
         r->right = q;
         q->left = r;
         // tao hai lien ket giua p va q
         q->right = p;
         p->left = q;
      }
   }
}

// Tac vu pop: xoa nut o dau danh sach lien ket
doan pop(NODEPTR *plist)
{
   NODEPTR p;
   doan x;
   if(empty(plist))  // truong hop danh sach rong
      printf("Danh sach rong, khong xoa nut duoc");
   else
   {
      p = *plist;  // p la nut can xoa
      x = p->info;
      if((*plist)->right == NULL)  // truong hop danh sach co mot nut
         *plist = NULL;
      else
      {
         *plist = p->right;
         (*plist)->left = NULL;
      }
      freenode(p);
      return(x);
   }
}

// Tac vu delnode: xoa nut co con tro la p
doan delnode(NODEPTR *plist, NODEPTR p)
{
   NODEPTR q, r;
   doan x;
   if(p == NULL)
      printf("Nut p khong hien huu, khong xoa nut duoc\n");
   else
   {
      if(*plist == NULL)  // truong hop danh sach rong
         printf("Danh sach rong, khong xoa nut duoc");
      else
      {
         if(p == *plist)  // truong hop xoa nut dau
            x = pop(plist);
         else
         {
            x = p->info;
            q = p->left;   // q la nut truoc
            r = p->right;  // r la nut sau
            // tao hai lien ket giua q va r
            r->left = q;
            q->right = r;
            freenode(p);
         }
         return(x);
      }
   }
}

// Tac vu righttraverse: duyet danh sach tu trai sang phai (duyet xuoi)
void righttraverse(NODEPTR *plist)
{
   NODEPTR p;
   int stt;
   if(empty(plist))
      printf("\n  (khong co doan nao)");
   else
   {
      p = *plist;  // p chi nut dau
      stt = 0;
      while(p != NULL)
      {
         printf("\n%5d%12s%12s%7d%7d", stt++, p->info.gatruoc, p->info.gasau,
                                       p->info.chieudai, p->info.thoigian);
         p = p->right;
      }
   }
}

// Tac vu lefttraverse: duyet danh sach tu phai sang trai (duyet nguoc)
void lefttraverse(NODEPTR *plist)
{
   NODEPTR p;
   int stt;
   if(empty(plist))
      printf("\n  (khong co doan nao)");
   else
   {
      stt = 0;
      p = nodepointer(plist, listsize(plist)-1);  // p chi nut cuoi
      while(p != NULL)
      {
         printf("\n%5d%12s%12s%7d%7d", stt++, p->info.gasau, p->info.gatruoc,
                                       p->info.chieudai, p->info.thoigian);
         p = p->left;
      }
   }
}

// Tac vu search1: tim ga truoc cua mot doan
NODEPTR search1(NODEPTR *plist, char x[])
{
   NODEPTR p;
   p = *plist;
   while(strcmp(p->info.gatruoc, x) != 0 && p != NULL)
      p = p->right;
   return(p);
}

// Tac vu search2: tim ga sau cua mot doan
NODEPTR search2(NODEPTR *plist, char x[])
{
   NODEPTR p;
   p = *plist;
   while(strcmp(p->info.gasau, x) != 0 && p != NULL)
      p = p->right;
   return(p);
}

// Tac vu clearlist: xoa toan bo danh sach lien ket kep
void clearlist(NODEPTR *plist)
{
   while(*plist != NULL)
      pop(plist);
}

void baolotrinh(NODEPTR *plist, char noidi[], char noiden[], char c)
{
   NODEPTR p, p1;
   int kc, tg;

   if(c == 'x')
   {
	   p = search1(plist, noidi);
	   if(p == NULL)
	   {
         printf("Khong co noi di");
         return;
      }
      if(strcmp(noidi, noiden) == 0)
      {
         printf("Noi di trung noi den");
         return;
      }
	   p1 = search2(plist, noiden);
	   if(p1 == NULL)
	   {
         printf("Khong co noi den");
         return;
      }

      if(position(plist, p) <= position(plist, p1))
      {
         kc = tg = 0;
         while(p != p1)
         {
            kc = kc + p->info.chieudai;
            tg = tg + p->info.thoigian;
            printf("\n%s -> %s :  %d km  %d gio", p->info.gatruoc,
                    p->info.gasau, p->info.chieudai, p->info.thoigian);
            p = p->right;
         }
         kc = kc + p1->info.chieudai;
         tg = tg + p1->info.thoigian;
         printf("\n%s -> %s :  %d km  %d gio", p1->info.gatruoc,
                 p1->info.gasau, p1->info.chieudai, p1->info.thoigian);

         printf("\nTong chieu dai lo trinh: %d km. Tong thoi gian van chuyen %d gio", kc, tg);
      }
      else
         printf("Khong di xuoi duoc");
      return;
   }

   if(c == 'n')
   {
	   p = search2(plist, noidi);
	   if(p == NULL)
	   {
         printf("Khong co noi di");
         return;
      }
      if(strcmp(noidi, noiden) == 0)
      {
         printf("Noi di trung noi den");
         return;
      }
	   p1 = search1(plist, noiden);
	   if(p1 == NULL)
	   {
         printf("Khong co noi den");
         return;
      }

      if(position(plist, p) >= position(plist, p1))
      {
         kc = tg = 0;
         while(p != p1)
         {
            kc = kc + p->info.chieudai;
            tg = tg + p->info.thoigian;
            printf("\n%s -> %s :  %d km  %d gio", p->info.gasau,
                    p->info.gatruoc, p->info.chieudai, p->info.thoigian);
            p = p->left;
         }
         kc = kc + p1->info.chieudai;
         tg = tg + p1->info.thoigian;
         printf("\n%s -> %s :  %d km  %d gio", p1->info.gasau,
                 p1->info.gatruoc, p1->info.chieudai, p1->info.thoigian);

         printf("\nTong chieu dai lo trinh: %d km. Tong thoi gian van chuyen %d gio", kc, tg);
      }
      else
         printf("Khong di nguoc duoc");
      return;
   }
}

// chuong trinh chinh
void main()
{
   NODEPTR plist, p, p1;
   doan ga;
   int vitri, chucnang;
   char c;
   char noidi[12], noiden[12];

   clrscr();

   // khoi dong danh sach lien ket kep
   initialize(&plist);

   do
   {
      // menu chinh cua chuong trinh
      printf("\n\nCHUONG TRINH QUAN LY VA DIEU HANH TUYEN XE LUA TPHCM - HANOI\n");
      printf("   1: Them mot doan\n");
      printf("   2: Xoa mot doan\n");
      printf("   3: Xem lo trinh 1 (duyet xuoi)\n");
      printf("   4: Xem lo trinh 2 (duyet nguoc)\n");
      printf("   5: Xem thong tin cua doan thu i\n");
      printf("   6: Hieu chinh thong tin ve doan thu i\n");
      printf("   7: Bao lo trinh\n");
      printf("   0: Ket thuc chuong trinh\n");
      printf("Chuc nang ban chon: ");
      scanf("%d", &chucnang);
      switch(chucnang)
      {
         case 1:
	      {
	         printf("\nVi tri (0,1,2,...): ");
	         scanf("%d", &vitri);
	         printf("Ten ga truoc: ");
	         scanf("%s", &ga.gatruoc);
	         printf("Ten ga sau: ");
	         scanf("%s", &ga.gasau);
	         printf("Chieu dai (km): ");
	         scanf("%d", &ga.chieudai);
	         printf("Thoi gian (gio): ");
	         scanf("%d", &ga.thoigian);
	         if(vitri == 0)
	            push(&plist, ga);
	         else
	            insertright(nodepointer(&plist, vitri-1), ga);
	         break;
	      }
	      case 2:
	      {
	         printf("\nVi tri (0,1,2,...): ");
	         scanf("%d", &vitri);
            p = nodepointer(&plist, vitri);
            if(p == NULL)
               printf("Vi tri khong hop le");
            else
	            if(vitri == 0)
	               pop(&plist);
	            else
	               delnode(&plist, p);
	         break;
	      }
	      case 3:
	      {
	         printf("\nXem lo trinh 1 (duyet xuoi): ");
            printf("\n  STT          TU         DEN     CD     TG");
	         righttraverse(&plist);
	         break;
	      }
	      case 4:
	      {
	         printf("\nXem lo trinh 2 (duyet nguoc): ");
            printf("\n  STT          TU         DEN     CD     TG");
	         lefttraverse(&plist);
	         break;
	      }
	      case 5:
	      {
	         printf("\nVi tri (0,1,2,...): ");
	         scanf("%d", &vitri);
            p = nodepointer(&plist, vitri);
            if(p == NULL)
               printf("Vi tri khong hop le");
            else
               printf("\nDoan:%d  Tu:%s  Den:%s  Chieu dai:%d km  Thoi gian:%d gio",
                      vitri, p->info.gatruoc, p->info.gasau,
                      p->info.chieudai, p->info.thoigian);
	         break;
	      }
	      case 6:
	      {
	         printf("\nVi tri: ");
	         scanf("%d", &vitri);
            p = nodepointer(&plist, vitri);
            if(p == NULL)
               printf("Vi tri khong hop le");
            else
            {
               printf("\nDoan:%d  Tu:%s  Den:%s  Chieu dai:%d km  Thoi gian:%d gio",
                      vitri, p->info.gatruoc, p->info.gasau,
                      p->info.chieudai, p->info.thoigian);
	            printf("\nTen ga truoc: ");
	            scanf("%s", &ga.gatruoc);
	            printf("Ten ga sau: ");
	            scanf("%s", &ga.gasau);
	            printf("Chieu dai (km): ");
	            scanf("%d", &ga.chieudai);
	            printf("Thoi gian (gio): ");
	            scanf("%d", &ga.thoigian);
	            p->info = ga;
            }
	         break;
	      }
	      case 7:
	      {
            printf("\nBan di xuoi hay nguoc (x/n): ");
            c = getche();
	         printf("\nCho biet noi di: ");
	         scanf("%s", &noidi);
	         printf("\nCho biet noi den: ");
	         scanf("%s", &noiden);
            baolotrinh(&plist, noidi, noiden, c);
	         break;
	      }
      }
   } while(chucnang != 0);

   // Xoa toan bo cac nut tren danh sach lien ket
   clearlist(&plist);
}