/*****************************************************************************
* Chuong trinh C6-1: Chuong trinh minh hoa cay nhi phan cai dat theo kieu    *
* lien ket. Moi nut duoc cap phat bang mot phan tu cua mang.                 *
* Nguoi viet chuong trinh: Nguyen Hong Chuong                                *
* Ngay cap nhat moi nhat: 15/3/1999                                          *
*****************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <conio.h>

#define TRUE 1
#define FALSE 0
#define NUMNODES 500

struct nodetype
{
   int info;
   int left;
   int right;
};
struct nodetype nodes[NUMNODES];

int avail;  // avail duoc khai bao la bien toan cuc

// Tac vu getnode: cap phat mot phan tu cua mang cho cay nhi phan
int getnode(void)
{
   int p;
   if(avail == -1)     // het tap nut danh san
      printf("Het tap nut danh san, khong cap phat duoc\n");

   // cap phat nut avail trong tap nut danh san, avail chi nut cap phat tiep
   else
   {
      p = avail;
      avail = nodes[avail].left;
      return(p);
   }
}

// Tac vu freenode: huy phan tu da cap phat
void freenode(int p)
{
   // chen nut bi huy vao dau tap nut danh san
   nodes[p].left = avail;
   avail = p;
}

// Tac vu initialize: khoi dong cay nhi phan
void initialize(int *ptree)
{
   *ptree = -1;
}

// Tac vu empty: kiem tra cay nhi phan co bi rong khong
int empty(int *ptree)
{
   return(*ptree == -1 ? TRUE : FALSE);
}

/* Tac vu makenode: tao mot nut (nut la) cho cay nhi phan, noi dung nut nay
   la x */
int makenode(int x)
{
   int p;
   p = getnode();
   nodes[p].info = x;
   nodes[p].left = -1;
   nodes[p].right = -1;
   return(p);
}

// Tac vu setleft: tao nut co khoa x la nut con ben trai cua nut p
void setleft(int p, int x)
{
   if(p == -1)
      printf("Nut p khong hien huu\n");
   else
      if(nodes[p].left != -1)
	      printf("Nut p da co nut con ben trai\n");
      else
	      nodes[p].left = makenode(x);
}

// Tac vu setright: tao nut co khoa x la nut con ben phai cua nut p
void setright(int p, int x)
{
   if(p == -1)
      printf("Nut p khong hien huu\n");
   else
      if(nodes[p].right != -1)
	      printf("Nut p da co nut con ben phai\n");
      else
	      nodes[p].right = makenode(x);
}

// Tac vu delleft: xoa nut con ben trai (nut la) cua nut p
int delleft(int p)
{
   int q;
   int x;
   if(p == -1)
      printf("Nut p khong hien huu\n");
   else
   {
      q = nodes[p].left;
      x = nodes[q].info;
      if(q == -1)
	      printf("Nut p khong co nut con ben trai\n");
      else
         if(nodes[q].left != -1 || nodes[q].right != -1)
	         printf("Nut q khong la nut la, khong xoa nut duoc\n");
         else
         {
	         nodes[p].left = -1;
            freenode(q);
            return(x);
         }
   }
}

// Tac vu delright: xoa nut con ben phai (nut la) cua nut p
int delright(int p)
{
   int q;
   int x;
   if(p == -1)
      printf("Nut p khong hien huu\n");
   else
   {
      q = nodes[p].right;
      x = nodes[q].info;
      if(q == -1)
	      printf("Nut p khong co nut con ben phai\n");
      else
         if(nodes[q].left != -1 || nodes[q].right != -1)
	         printf("Nut q khong la nut la, khong xoa nut duoc\n");
         else
         {
	         nodes[p].right = -1;
            freenode(q);
            return(x);
         }
   }
}

// Tac vu pretrav: duyet cay theo thu tu truoc (NLR)
void pretrav(int proot)
{
   if(proot != -1)
   {
      printf("%d ", nodes[proot].info);
      pretrav(nodes[proot].left);
      pretrav(nodes[proot].right);
   }
}

// Tac vu intrav: duyet cay theo thu tu giua (LNR)
void intrav(int proot)
{
   if(proot != -1)
   {
      intrav(nodes[proot].left);
      printf("%d ", nodes[proot].info);
      intrav(nodes[proot].right);
   }
}

// Tac vu posttrav: duyet cay theo thu tu sau (LRN)
void posttrav(int proot)
{
   if(proot != -1)
   {
      posttrav(nodes[proot].left);
      posttrav(nodes[proot].right);
      printf("%d ", nodes[proot].info);
   }
}

/* Tac vu search: (de qui) tim kiem nut co noi dung la x tren cay con co nut
   goc proot. Neu tim thay thi ham nay se tra ve con tro chi nut tim thay, neu
   khong tim thay thi ham tra ve gia tri -1 */
int search(int proot, int x)
{
   int p;

   // dieu kien dung
   if(nodes[proot].info == x)
      return(proot);
   if(proot == -1)
      return(-1);

   // buoc de qui
   p = search(nodes[proot].left, x);
   if(p == -1)
      p = search(nodes[proot].right, x);
   return(p);
}

// Tac vu cleartree: xoa cay nhi phan
void cleartree(int proot)
{
   if(proot != -1)
   {
      cleartree(nodes[proot].left);
      cleartree(nodes[proot].right);
      freenode(proot);
   }
}

void main()
{
   int i, noidung, noidung1, chucnang;
   char c;
   int p;
   int ptree;

   clrscr();

   // Khoi dong tap nut danh san
   avail = 0;
   for(i = 0; i < NUMNODES; i++)
      nodes[i].left = i+1;
   nodes[NUMNODES-1].left = -1;

   initialize(&ptree);  // Khoi tao cay nhi phan

   do
   {
      // menu chinh cua chuong trinh
      printf("\n\n\t\tCAY NHI PHAN (BINARY TREE)");
      printf("\n\nCac chuc nang cua chuong trinh:\n");
      printf("   1: Tao nut goc cua cay nhi phan\n");
      printf("   2: Them mot nut la ben trai \n");
      printf("   3: Them mot nut la ben phai \n");
      printf("   4: Xoa mot nut la ben trai\n");
      printf("   5: Xoa mot nut la ben phai\n");
      printf("   6: Duyet cay theo thu tu truoc (NLR)\n");
      printf("   7: Duyet cay theo thu tu giua (LNR)\n");
      printf("   8: Duyet cay theo thu tu sau (LRN)\n");
      printf("   9: Tim kiem\n");
      printf("  10: Xoa toan bo cay\n");
      printf("   0: Ket thuc chuong trinh\n");
      printf("Chuc nang ban chon: ");
      scanf("%d", &chucnang);
      switch(chucnang)
      {
	      case 1:
	      {
	         if(!empty(&ptree))
	            printf("\nCay nhi phan da co nut goc");
            else
            {
	            printf("\nNoi dung cua nut goc: ");
	            scanf("%d", &noidung);
	            ptree = makenode(noidung);
            }
	         break;
	      }
	      case 2:
	      {
            if(empty(&ptree))
               printf("\nCay nhi phan dang bi rong, phai tao nut goc truoc");
            else
            {
	            printf("\nNoi dung nut la can them: ");
	            scanf("%d", &noidung);
               p = search(ptree, noidung);
               if(p != -1)
                  printf("\nBi trung noi dung, khong them nut duoc");
               else
               {
	               printf("\nNoi dung cua nut cha: ");
	               scanf("%d", &noidung1);
                  p = search(ptree, noidung1);
                  if(p == -1)
                     printf("\nKhong thay nut cha, khong them nut duoc");
                  else
                     setleft(p, noidung);
               }
            }
	         break;
	      }
	      case 3:
	      {
            if(empty(&ptree))
               printf("\nCay nhi phan dang bi rong, phai tao nut goc truoc");
            else
            {
	            printf("\nNoi dung nut la can them: ");
	            scanf("%d", &noidung);
               p = search(ptree, noidung);
               if(p != -1)
                  printf("\nBi trung noi dung, khong them nut duoc");
               else
               {
	               printf("\nNoi dung cua nut cha: ");
	               scanf("%d", &noidung1);
                  p = search(ptree, noidung1);
                  if(p == -1)
                     printf("\nKhong thay nut cha, khong them nut duoc");
                  else
                     setright(p, noidung);
               }
            }
	         break;
	      }
	      case 4:
	      {
	         printf("\nNoi dung cua nut cha: ");
	         scanf("%d", &noidung);
	         p = search(ptree, noidung);
            if(p == -1)
               printf("\nKhong thay nut cha, khong xoa nut duoc");
            else
               delleft(p);
	         break;
	      }
	      case 5:
	      {
	         printf("\nNoi dung cua nut cha: ");
	         scanf("%d", &noidung);
	         p = search(ptree, noidung);
            if(p == -1)
               printf("\nKhong thay nut cha, khong xoa nut duoc");
            else
               delright(p);
	         break;
	      }
	      case 6:
	      {
	         printf("\nDuyet cay theo thu tu truoc (NLR):\n");
	         if(empty(&ptree))
	            printf("Cay bi rong");
	         else
	            pretrav(ptree);
	         break;
	      }
	      case 7:
	      {
	         printf("\nDuyet cay theo thu tu giua (LNR):\n");
	         if(empty(&ptree))
	            printf("Cay bi rong");
	         else
	            intrav(ptree);
	         break;
	      }
	      case 8:
	      {
	         printf("\nDuyet cay theo thu tu sau (LRN):\n");
	         if(empty(&ptree))
	            printf("Cay bi rong");
	         else
	            posttrav(ptree);
	         break;
	      }
	      case 9:
	      {
	         printf("\nNoi dung can tim: ");
	         scanf("%d", &noidung);
	         if(search(ptree, noidung) != -1)
	            printf("Tim thay");
	         else
	            printf("Khong tim thay");
	         break;
	      }
	      case 10:
	      {
	         printf("\nBan co chac khong (c/k): ");
	         c = getche();
	         if(c == 'c' || c == 'C')
               cleartree(ptree);
               ptree = -1;
	         break;
	      }
      }
   } while(chucnang != 0);
   cleartree(ptree);
   ptree = -1;
}