/*****************************************************************************
* Chuong trinh C6-2: Chuong trinh minh hoa cay nhi phan hoan toan can bang,  *
* hien thuc theo kieu lien ket dung bien dong.                               *
* Nguoi viet chuong trinh: Nguyen Hong Chuong                                *
* Ngay cap nhat moi nhat: 15/3/1999                                          *
*****************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <alloc.h>

struct nodetype
{
   int info;
   int sonut;
   struct nodetype *left;
   struct nodetype *right;
};
typedef struct nodetype *NODEPTR;

// Tac vu getnode: cap phat mot bien dong cho cay nhi phan htcb
NODEPTR getnode(void)
{
   NODEPTR p;
   p = (NODEPTR)malloc(sizeof(struct nodetype));
   return(p);
}

// Tac vu freenode: huy bien dong da cap phat
void freenode(NODEPTR p)
{
   free(p);
}

// Tac vu initialize: khoi dong cay nhi phan htcb
void initialize(NODEPTR *ptree)
{
   *ptree = NULL;
}

// Tac vu makenode: cap phat mot nut (nut la) cho cay nhi phan htcb
NODEPTR makenode(int x)
{
   NODEPTR p;
   p = getnode();
   p->info = x;
   p->sonut = 1;
   p->left = NULL;
   p->right = NULL;
   return(p);
}

/* Tac vu setleft: tao nut co noi dung x la nut con (nut la) ben trai cua
   nut p */
void setleft(NODEPTR p, int x)
{
   if(p == NULL)
      printf("Nut p khong hien huu\n");
   else
      if(p->left != NULL)
	      printf("Nut p da co nut con ben trai\n");
      else
	      p->left = makenode(x);
}

/* Tac vu setright: tao nut co noi dung x la nut con (nut la) ben phai cua
   nut p */
void setright(NODEPTR p, int x)
{
   if(p == NULL)
       printf("Nut p khong hien huu\n");
   else
      if(p->right != NULL)
	      printf("Nut p da co cay con ben phai\n");
      else
	      p->right = makenode(x);
}

// Tac vu pretrav: duyet cay theo thu tu truoc (NLR)
void pretrav(NODEPTR proot)
{
   if(proot != NULL)
   {
      printf("%d ", proot->info);
      pretrav(proot->left);
      pretrav(proot->right);
   }
}

// Tac vu intrav: duyet cay theo thu tu giua (LNR)
void intrav(NODEPTR proot)
{
   if(proot != NULL)
   {
      intrav(proot->left);
      printf("%d ", proot->info);
      intrav(proot->right);
   }
}

// Tac vu posttrav: duyet cay theo thu tu sau (LRN)
void posttrav(NODEPTR proot)
{
   if(proot != NULL)
   {
      posttrav(proot->left);
      posttrav(proot->right);
      printf("%d ", proot->info);
   }
}

/* Tac vu insert: them nut co khoa x vao cay nhi phan htcb co nut goc proot */
void insert(NODEPTR proot, int x)
{
   NODEPTR p;               // p la nut cha, q la nut con
   p = proot;
   while(p->sonut != 1 && p->sonut != 2)
   {
      if(p->sonut % 2 == 1)
      {
	      p->sonut++;
	      p = p->left;
      }
      else   // p->sonut % 2 == 0
      {
	      p->sonut++;
	      p = p->right;
      }
   }
   if(p->sonut == 1)
   {
      p->sonut++;
      setleft(p, x);
   }
   else       // p->sonut = 2
   {
      p->sonut++;
      setright(p, x);
   }
}

/* Tac vu search: (de qui) tim kiem nut co noi dung la x tren cay con co nut
   goc proot. Neu tim thay thi ham nay se tra ve con tro chi nut tim thay, neu
   khong tim thay thi ham tra ve gia tri NULL */
NODEPTR search(NODEPTR proot, int x)
{
   NODEPTR p;

   // dieu kien dung
   if(proot->info == x)
      return(proot);
   if(proot == NULL)
      return(NULL);

   // buoc de qui
   p = search(proot->left, x);
   if(!p)
      p = search(proot->right, x);
   return(p);
}

// Tac vu cleartree: xoa cay nhi phan
void cleartree(NODEPTR proot)
{
   if(proot != NULL)
   {
      cleartree(proot->left);
      cleartree(proot->right);
      freenode(proot);
   }
}

// Chuong trinh chinh
void main()
{
   NODEPTR ptree, p;
   int noidung, chucnang;
   char c;

   clrscr();
   initialize(&ptree);  // Khoi dong cay nhi phan

   do
   {
      // menu chinh cua chuong trinh
      printf("\n\n\t\tCAY NHI PHAN HOAN TOAN CAN BANG");
      printf("\n\nCac chuc nang cua chuong trinh:\n");
      printf("   1: Them nut\n");
      printf("   2: Duyet cay theo thu tu truoc (NLR)\n");
      printf("   3: Duyet cay theo thu tu giua (LNR)\n");
      printf("   4: Duyet cay theo thu tu sau (LRN)\n");
      printf("   5: Tim kiem\n");
      printf("   6: Xoa toan bo cay\n");
      printf("   0: Ket thuc chuong trinh\n");
      printf("Chuc nang ban chon: ");
      scanf("%d", &chucnang);
      switch(chucnang)
      {
	      case 1:
	      {
	         printf("\nNoi dung nut moi: ");
	         scanf("%d", &noidung);
	         if(ptree == NULL)     // tao nut goc cua cay
	            ptree = makenode(noidung);
	         else
	            insert(ptree, noidung);
	         break;
	      }
	      case 2:
	      {
	         printf("\nDuyet cay theo thu tu truoc (NLR):\n");
	         if(!ptree)
	            printf("Cay bi rong");
	         else
	            pretrav(ptree);
	         break;
	      }
	      case 3:
	      {
	         printf("\nDuyet cay theo thu tu giua (LNR):\n");
	         if(!ptree)
	            printf("Cay bi rong");
	         else
	            intrav(ptree);
	         break;
	      }
	      case 4:
	      {
	         printf("\nDuyet cay theo thu tu sau (LRN):\n");
	         if(!ptree)
	            printf("Cay bi rong");
	         else
	            posttrav(ptree);
	         break;
	      }
	      case 5:
	      {
	         printf("\nNoi dung can tim: ");
	         scanf("%d", &noidung);
	         if(search(ptree, noidung))
	            printf("Tim thay");
	         else
	            printf("Khong tim thay");
	         break;
	      }
         case 6:
         {
	         printf("\nBan co chac khong (c/k): ");
	         c = getche();
	         if(c == 'c' || c == 'C')
            {
               cleartree(ptree);
               ptree = NULL;
            }
            break;
         }
      }
   } while(chucnang != 0);

   // xoa cay truoc khi ket thuc chuong trinh
   cleartree(ptree);
   ptree = NULL;
}           2