/*****************************************************************************
* Chuong trinh C6-3: Chuong trinh minh hoa cay nhi phan tim kiem, cai dat    *
* theo kieu lien ket - dung bien dong.                                       *
* Nguoi viet chuong trinh: Nguyen Hong Chuong                                *
* Ngay cap nhat moi nhat: 15/3/1999                                          *
*****************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <alloc.h>

struct nodetype
{
   int info;
   struct nodetype *left;
   struct nodetype *right;
};
typedef struct nodetype *NODEPTR;

// Tac vu getnode: cap phat mot bien dong
NODEPTR getnode(void)
{
   NODEPTR p;
   p = (NODEPTR)malloc(sizeof(struct nodetype));
   return(p);
}

// Tac vu freenode: huy mot bien dong da cap phat
void freenode(NODEPTR p)
{
   free(p);
}

// Tac vu initialize: khoi dong cay nhi phan tim kiem
void initialize(NODEPTR *pbstree)
{
   *pbstree = NULL;
}

/* Tac vu makenode: tao mot nut (nut la) cho cay nhi phan tim kiem, noi dung
   nut nay la x */
NODEPTR makenode(int x)
{
   NODEPTR p;
   p = getnode();
   p->info = x;
   p->left = NULL;
   p->right = NULL;
   return(p);
}

// Tac vu setleft: tao nut la co noi dung x la nut con ben trai cua nut p
void setleft(NODEPTR p, int x)
{
   if(p == NULL)
      printf("Nut cha khong hien huu\n");
   else
      if(p->left != NULL)
	      printf("Nut cha da co nut con ben trai\n");
      else
	      p->left = makenode(x);
}

// Tac vu setright: tao nut la co noi dung x la nut con ben phai cua nut p
void setright(NODEPTR p, int x)
{
   if(p == NULL)
      printf("Nut cha khong hien huu\n");
   else
      if(p->right != NULL)
	      printf("Nut cha da co nut con ben phai\n");
      else
	      p->right = makenode(x);
}

// Tac vu pretrav: duyet cay theo thu tu truoc (NLR)
void pretrav(NODEPTR proot)
{
   if(proot == NULL)    // dieu kien dung
      return;
   else                 // buoc de qui
   {
      printf("%d ", proot->info);
      pretrav(proot->left);
      pretrav(proot->right);
   }
}

// Tac vu intrav: duyet cay theo thu tu giua (LNR)
void intrav(NODEPTR proot)
{
   if(proot == NULL)    // dieu kien dung
      return;
   else                 // buoc de qui
   {
      intrav(proot->left);
      printf("%d ", proot->info);
      intrav(proot->right);
   }
}

// Tac vu posttrav: duyet cay theo thu tu sau (LRN)
void posttrav(NODEPTR proot)
{
   if(proot == NULL)    // dieu kien dung
      return;
   else                 // buoc de qui
   {
      posttrav(proot->left);
      posttrav(proot->right);
      printf("%d ", proot->info);
   }
}

/* Tac vu search: dung phuong phap de qui tim kiem nut co noi dung x tren cay
   nhi phan tim kiem co nut goc la proot. Neu tim thay thi ham nay se tra ve
   con tro chi nut can tim, neu khong tim thay thi ham tra ve con tro NULL */
NODEPTR search(NODEPTR proot, int x)
{
   NODEPTR p;
   p = proot;
   if(p != NULL)
      if(x < proot->info)
	      p = search(proot->left, x);
      else
	      if(x > proot->info)
	         p = search(proot->right, x);
   return(p);
}

/* Tac vu search: (khong dung phuong phap de qui) tim kiem nut co noi dung x
   tren cay nhi phan tim kiem (proot la nut goc cua cay nay). Neu tim thay
   thi ham nay tra ve con tro chi nut can tim, neu khong tim thay thi ham tra
   ve con tro NULL */
/*
NODEPTR search(NODEPTR proot, int x)
{
   NODEPTR p;
   p = proot;
   while(p != NULL)
   {
      if(x == p->info)
	      return(p);     // tim thay
      else
	      if(x < p->info)
	         p = p->left;
	      else
	         p = p->right;
   }
   return(NULL);        // khong thay
}
*/

/* Tac vu insert: dung phuong phap de qui them nut co noi dung x vao cay co
   nut goc proot */
void insert(NODEPTR proot, int x)
{
   if(x == proot->info)                         // dieu kien dung
   {
      printf("bi trung noi dung, khong them nut nay duoc");
      return;
   }
   if(x < proot->info && proot->left == NULL)   // dieu kien dung
   {
      setleft(proot, x);
      return;
   }
   if(x > proot->info && proot->right == NULL)  // dieu kien dung
   {
      setright(proot, x);
      return;
   }
   if(x < proot->info)                          // buoc de qui
      insert(proot->left, x);
   else
      insert(proot->right, x);
}

/* Tac vu insert: (khong dung phuong phap de qui) them nut co noi dung x vao
   cay co nut goc proot */
/*
void insert(NODEPTR proot, int x)
{
   NODEPTR p, q;               // p la nut cha, q la nut con
   p = q = proot;
   while(x != p->info && q != NULL)
   {
      p = q;
      if(x < p->info)
	      q = p->left;
      else
	      q = p->right;
   }
   if(x == p->info)
      printf("bi trung noi dung, khong them nut nay duoc");
   else
      if(x < p->info)
	      setleft(p, x);
      else
	      setright(p, x);
}
*/

// Tac vu remove: xoa nut p, tac vu nay tra ve con tro chi nut the mang
NODEPTR remove(NODEPTR p)
{
   NODEPTR rp, f;     // rp la nut the mang cho nut p, f la nut cha cua rp
   if(p == NULL)
      printf("Nut p khong hien huu, khong xoa nut duoc");
   else
   {
      if(p->right == NULL)      // nut p khong co cay con ben phai
         rp = p->left;
      else
      {
         if(p->left == NULL)    // nut p khong co cay con ben trai
	         rp = p->right;
         else    // nut p co hai cay con ben trai va ben phai
         {
            /* tim nut the mang rp la nut trai nhat cua cay con ben phai,
            goi f la nut cha cua nut rp */
            f = p;
            rp = p->right;
            while(rp->left != NULL)
            {
               f = rp;
               rp = rp->left;
            }
            if(f != p)
            {
               f->left = rp->right;
               rp->right = p->right;
            }
            rp->left = p->left;
         }
      }
      freenode(p);
      return(rp);
   }
}

// Tac vu remove: xoa nut co con tro la noi dung cua p
/*void remove(NODEPTR *p)
{
   NODEPTR q, r;
   r = *p;    // r la nut se bi xoa
   if(r->right == NULL)
   {
      *p = r->left;     // thay doi noi dung cua p la r->left
      freenode(r);
   }
   else
      if(r->left == NULL)
      {
	      *p = r->right; // thay doi noi dung cua p la r->right
	      freenode(r);
      }
      else  // nut can xoa co cay con ben trai lan ben phai
      {
	      // vong lap tim nut trai nhat cua cay con ben phai
	      for(q = r->right; q->left; q = q->left)
	         ;
	      q->left = r->left;
	      *p = r->right; // thay doi noi dung cua p la r->right
	      freenode(r);
      }
}*/

/* Tac vu rotateleft: xoay trai cay nhi phan tim kiem co nut goc la proot,
   yeu cau proot phai co nut con ben phai (goi la nut p)
   Sau khi xoay trai thi nut con ben phai p tro thanh nut goc, nut goc cu tro
   thanh nut con ben trai cua nut goc moi
   Tac vu nay tra ve con tro chi nut goc moi */
NODEPTR rotateleft(NODEPTR proot)
{
   NODEPTR p;
   p = proot;
   if(proot == NULL)
      printf("Khong the xoay trai vi cay bi rong.");
   else
      if(proot->right == NULL)
	      printf("Khong the xoay trai vi khong co nut con ben phai.");
      else
      {
	      p = proot->right;
	      proot->right = p->left;
	      p->left = proot;
      }
   return p;
}

/* Tac vu rotateright: xoay phai cay nhi phan tim kiem co nut goc la proot,
   yeu cau proot phai co nut con ben trai (goi la nut p)
   Sau khi xoay phai thi nut con ben trai p tro thanh nut goc, nut goc cu tro
   thanh nut con ben phai cua nut goc moi
   Tac vu nay tra ve con tro chi nut goc moi */
NODEPTR rotateright(NODEPTR proot)
{
   NODEPTR p;
   p = proot;
   if(proot == NULL)
      printf("Khong the xoay phai vi cay bi rong.");
   else
      if(proot->left == NULL)
	      printf("Khong the xoay phai vi khong co nut con ben trai.");
      else
      {
	      p = proot->left;
	      proot->left = p->right;
	      p->right = proot;
      }
   return p;
}

// Chuong trinh chinh
void main()
{
   int noidung, chucnang;
   char c;
   NODEPTR pbstree, p;

   clrscr();
   initialize(&pbstree);  // Khoi dong cay nhi phan tim kiem

   do
   {
      // Menu chinh cua chuong trinh
      printf("\n\nCAY NHI PHAN TIM KIEM - CAI DAT THEO KIEU LIEN KET, DUNG BIEN DONG");
      printf("\nCac chuc nang cua chuong trinh:\n");
      printf("   1: Them nut\n");
      printf("   2: Xoa nut goc\n");
      printf("   3: Xoa nut con ben trai\n");
      printf("   4: Xoa nut con ben phai\n");
      printf("   5: Xoa toan bo cay\n");
      printf("   6: Duyet theo thu tu truoc (NLR)\n");
      printf("   7: Duyet theo thu tu giua (LNR)\n");
      printf("   8: Duyet theo thu tu sau (LRN)\n");
      printf("   9: Xoay trai cay nhi phan tim kiem\n");
      printf("  10: Xoay trai cay con ben phai\n");
      printf("  11: Xoay trai cay con ben trai\n");
      printf("  12: Xoay phai cay nhi phan tim kiem\n");
      printf("  13: Xoay phai cay con ben phai\n");
      printf("  14: Xoay phai cay con ben trai\n");
      printf("  15: Tim kiem\n");
      printf("   0: Ket thuc chuong trinh\n");
      printf("Chuc nang ban chon: ");
      scanf("%d", &chucnang);
      switch(chucnang)
      {
	      case 1:
	      {
	         printf("\nNoi dung nut moi: ");
	         scanf("%d", &noidung);
	         if(pbstree == NULL)  // neu cay dang bi rong thi tao nut goc
	            pbstree = makenode(noidung);
	         else
	            insert(pbstree, noidung);
	         break;
	      }
	      case 2:
	      {
            if(pbstree == NULL)
               printf("Cay bi rong, khong xoa nut goc duoc");
            else
	            pbstree = remove(pbstree);
	         break;
	      }
	      case 3:
	      {
	         printf("\nCho biet noi dung cua nut cha: ");
	         scanf("%d", &noidung);
	         p = search(pbstree, noidung);
	         if(p != NULL)
	            p->left = remove(p->left);
	         else
	            printf("Khong thay nut cha");
	         break;
	      }
	      case 4:
	      {
	         printf("\nCho biet noi dung cua nut cha: ");
	         scanf("%d", &noidung);
	         p = search(pbstree, noidung);
	         if(p != NULL)
	            p->right = remove(p->right);
	         else
	            printf("Khong thay nut cha");
	         break;
	      }
	      case 5:
	      {
	         /* chuc nang nay tuong ung voi tac vu cleartree, dung tac vu
	         remove trong vong lap while de lan luot xoa cac nut goc cua cay*/
	         printf("\nBan co chac khong (c/k): ");
	         c = getche();
	         if(c == 'c' || c == 'C')
	            while(pbstree)
		            pbstree = remove(pbstree);
	         break;
	      }
	      case 6:
	      {
	         printf("\nDuyet cay theo thu tu truoc (NLR):\n");
	         if(pbstree == NULL)
	            printf("Cay bi rong");
	         else
	            pretrav(pbstree);
	         break;
	      }
	      case 7:
	      {
	         printf("\nDuyet cay theo thu tu giua (LNR):\n");
	         if(pbstree == NULL)
	            printf("Cay bi rong");
	         else
	            intrav(pbstree);
	         break;
	      }
	      case 8:
	      {
	         printf("\nDuyet cay theo thu tu sau (LRN):\n");
	         if(pbstree == NULL)
	            printf("Cay bi rong");
	         else
	            posttrav(pbstree);
	         break;
	      }
	      case 9:
	      {
	         printf("\nBan co chac khong (c/k): ");
	         c = getche();
	         if(c == 'c' || c == 'C')
	            pbstree = rotateleft(pbstree);
	         break;
	      }
	      case 10:
	      {
	         printf("\nBan co chac khong (c/k): ");
	         c = getche();
	         if(c == 'c' || c == 'C')
	         {
	            printf("\nNoi dung nut cha: ");
	            scanf("%d", &noidung);
	            p = search(pbstree, noidung);
	            if(p != NULL)
		            p->right = rotateleft(p->right);
	            else
		            printf("Khong thay nut cha");
	         }
	         break;
	      }
	      case 11:
	      {
	         printf("\nBan co chac khong (c/k): ");
	         c = getche();
	         if(c == 'c' || c == 'C')
	         {
	            printf("\nNoi dung nut cha: ");
	            scanf("%d", &noidung);
	            p = search(pbstree, noidung);
	            if(p != NULL)
		            p->left = rotateleft(p->left);
	            else
		            printf("Khong thay nut cha");
	         }
	         break;
	      }
	      case 12:
	      {
	         printf("\nBan co chac khong (c/k): ");
	         c = getche();
	         if(c == 'c' || c == 'C')
	            pbstree = rotateright(pbstree);
	         break;
	      }
	      case 13:
	      {
	         printf("\nBan co chac khong (c/k): ");
	         c = getche();
	         if(c == 'c' || c == 'C')
	         {
	            printf("\nNoi dung nut cha: ");
	            scanf("%d", &noidung);
	            p = search(pbstree, noidung);
	            if(p != NULL)
		            p->right = rotateright(p->right);
	            else
		            printf("Khong thay nut cha");
	         }
	         break;
	      }
	      case 14:
	      {
	         printf("\nBan co chac khong (c/k): ");
	         c = getche();
	         if(c == 'c' || c == 'C')
	         {
	            printf("\nNoi dung nut cha: ");
	            scanf("%d", &noidung);
	            p = search(pbstree, noidung);
	            if(p != NULL)
		            p->left = rotateright(p->left);
	            else
		            printf("Khong thay nut cha");
	         }
	         break;
	      }
	      case 15:
	      {
	         printf("\nNoi dung can tim: ");
	         scanf("%d", &noidung);
	         if(search(pbstree, noidung))
	            printf("Tim thay");
	         else
	            printf("Khong tim thay");
	         break;
	      }
      }
   } while(chucnang != 0);

   // xoa tat ca cac nut truoc khi thoat
	while(pbstree)
		pbstree = remove(pbstree);
}