/*****************************************************************************
* Chuong trinh C6-4: Chuong trinh minh hoa cay nhi phan tim kiem can bang    *
* (cay AVL)                                                                  *
* Nguoi viet chuong trinh: Nguyen Hong Chuong                                *
* Ngay cap nhat moi nhat: 15/3/1999                                          *
*****************************************************************************/

#include <stdio.h>
#include <conio.h>
#include <alloc.h>

// Khai bao nut cua cay AVL, truong bf la chi so can bang cua nut
struct nodetype
{
   int info;
   int bf;
   struct nodetype *left, *right;
};
typedef struct nodetype *NODEPTR;

// tac vu getnode: cap phat mot bien dong la mot nut cho cay AVL
NODEPTR getnode(void)
{
   NODEPTR p;
   p = (NODEPTR)malloc(sizeof(struct nodetype));
   return(p);
}

// tac vu freenode: huy bien dong cap phat
void freenode(NODEPTR p)
{
   free(p);
}

// tac vu initialize: khoi dong cay AVL
void initialize(NODEPTR *pavltree)
{
   *pavltree = NULL;
}

// Tac vu makenode: tao mot nut (nut la) cho cay AVL, luc nay truong bf=0
NODEPTR makenode(int x)
{
   NODEPTR p;
   p = getnode();
   p->info = x;
   p->bf = 0;
   p->left = NULL;
   p->right = NULL;
   return(p);
}

// Tac vu pretrav: duyet cay AVL theo thu tu truoc - NLR
void pretrav(NODEPTR proot)
{
   if(proot != NULL)
   {
      printf("%d ", proot->info);
      pretrav(proot->left);
      pretrav(proot->right);
   }
}

// Tac vu intrav: duyet cay AVL theo thu tu giua - LNR
void intrav(NODEPTR proot)
{
   if(proot != NULL)
   {
      intrav(proot->left);
      printf("%d ", proot->info);
      intrav(proot->right);
   }
}

// Tac vu posttrav: duyet cay AVL theo thu tu sau - LRN
void posttrav(NODEPTR proot)
{
   if(proot != NULL)
   {
      posttrav(proot->left);
      posttrav(proot->right);
      printf("%d ", proot->info);
   }
}

/* Tac vu search: tac vu nay dung phuong phap de qui tim nut co noi dung
   la x tren cay AVL (proot la nut goc cua cay nay). Neu tim thay thi ham
   nay se tra ve con tro chi nut tim thay, neu khong tim thay thi ham
   nay tra ve con tro NULL */
NODEPTR search(NODEPTR proot, int x)
{
   NODEPTR p;
   p = proot;
   if(p != NULL)
      if(x < proot->info)
	      p = search(proot->left, x);
      else
	      if(x > proot->info)
	         p = search(proot->right, x);
   return(p);
}

/* Tac vu search: tac vu nay khong dung phuong phap de qui, tim nut co
   noi dung la x tren cay AVL (proot la nut goc cua cay nay). Neu tim
   thay thi ham nay tra ve con tro chi nut tim thay, neu khong tim thay
   thi ham nay tra ve con tro NULL */
/*
NODEPTR search(NODEPTR proot, int x)
{
   NODEPTR p;
   p = proot;
   while(p != NULL)
   {
      if(x == p->info)
	      return(p);     // tim thay
      else
	      if(x < p->info)
	         p = p->left;
	      else
	         p = p->right;
   }
   return(NULL);        // khong tim thay
}
*/

/* Tac vu rotateleft: xoay trai cay nhi phan tim kiem co nut goc la proot,
   yeu cau proot phai co nut con ben phai (goi la nut p)
   Sau khi xoay trai thi nut con ben phai p tro thanh nut goc, nut goc cu tro
   thanh nut con ben trai cua nut goc moi
   Tac vu nay tra ve con tro chi nut goc moi */
NODEPTR rotateleft(NODEPTR proot)
{
   NODEPTR p;
   p = proot;
   if(proot == NULL)
      printf("Khong the xoay trai vi cay bi rong.");
   else
      if(proot->right == NULL)
	      printf("Khong the xoay trai vi khong co nut con ben phai.");
      else
      {
	      p = proot->right;
	      proot->right = p->left;
	      p->left = proot;
      }
   return p;
}

/* Tac vu rotateright: xoay phai cay nhi phan tim kiem co nut goc la proot,
   yeu cau proot phai co nut con ben trai (goi la nut p)
   Sau khi xoay phai thi nut con ben trai p tro thanh nut goc, nut goc cu tro
   thanh nut con ben phai cua nut goc moi
   Tac vu nay tra ve con tro chi nut goc moi */
NODEPTR rotateright(NODEPTR proot)
{
   NODEPTR p;
   p = proot;
   if(proot == NULL)
      printf("Khong the xoay phai vi cay bi rong.");
   else
      if(proot->left == NULL)
	      printf("Khong the xoay phai vi khong co nut con ben trai.");
      else
      {
	      p = proot->left;
	      proot->left = p->right;
	      p->right = proot;
      }
   return p;
}

/* Tac vu insert: them nut co noi dung x vao cay AVL:
   - Them nut theo giai thuat binh thuong
   - Can bang lai cay bang cach xoay don hay xoay kep */
void insert(NODEPTR *pavltree, int x)
{
   NODEPTR fp, p, q,    // fp la nut cha cua p, q la con cua p
           fya, ya,     /* ya la nut truoc gan nhat co the mat can bang
                           fya la nut cha cua ya */
           s;           // s la nut con cua ya theo huong mat can bang
   int imbal;           /* imbal =  1 neu bi lech ve nhanh trai
                                 = -1 neu bi lech ve nhanh phai */
   // Khoi dong cac gia tri
   fp = NULL;
   p = *pavltree;
   fya = NULL;
   ya = p;

   // tim nut fp, ya va fya, nut moi them vao la nut la con cua nut fp
   while(p != NULL)
   {
      if(x == p->info)  // bi trung noi dung
         return;
      if (x < p->info)
         q = p->left;
      else
         q = p->right;

      if(q != NULL)
         if(q->bf != 0) // truong hop chi so can bang cua q la 1 hay -1
         {
            fya = p;
            ya = q;
         }
      fp = p;
      p = q;
   }

   // Them nut moi (nut la) la con cua nut fp
   q = makenode(x);
   if(x < fp->info)
      fp->left = q;
   else
      fp->right = q;

   /* Hieu chinh chi so can bang cua tat ca cac nut giua ya va q, neu bi lech
      ve phia trai thi chi so can bang cua tat ca cac nut giua ya va q deu la
      1, neu bi lech ve phia phai thi chi so can bang cua tat ca cac nut giua
      ya va q deu la -1 */
   if(x < ya->info)
      p = ya->left;
   else
      p = ya->right;
   s = p;     // s la con nut ya
   while(p != q)
   {
      if(x < p->info)
      {
         p->bf = 1;
         p = p->left;
      }
      else
      {
         p->bf = -1;
         p = p->right;
      }
   }

   // xac dinh huong lech
   if(x < ya->info)
      imbal = 1;
   else
      imbal = -1;

   if(ya->bf == 0)
   {
      ya->bf = imbal;
      return;
   }
   if(ya->bf != imbal)
   {
      ya->bf = 0;
      return;
   }

   if(s->bf == imbal)   // Truong hop xoay don
   {
      if(imbal == 1)    // xoay phai - truong hop 1.a
         p = rotateright(ya);
      else              // xoay trai - truong hop 2.a
         p = rotateleft(ya);
      ya->bf = 0;
      s->bf = 0;
   }
   else                 // Truong hop xoay kep
   {
      if(imbal == 1)    // xoay kep trai-phai - truong hop 1.b
      {
         ya->left = rotateleft(s);
         p = rotateright(ya);
      }
      else              // xoay kep phai-trai - truong hop 2.b
      {
         ya->right = rotateright(s);
         p = rotateleft(ya);
      }
      if(p->bf == 0)    // truong hop p la nut moi them vao
      {
         ya->bf = 0;
         s->bf = 0;
      }
      else
         if(p->bf == imbal)
         {
            ya->bf = -imbal;
            s->bf = 0;
         }
         else
         {
            ya->bf = 0;
            s->bf = imbal;
         }
      p->bf = 0;
   }
   if(fya == NULL)
      *pavltree = p;
   else
      if(ya == fya->right)
         fya->right = p;
      else
         fya->left = p;
}

void main()
{
   int noidung, chucnang;
   NODEPTR pavltree, p;

   clrscr();
   initialize(&pavltree);       // Khoi dong cay AVL

   do
   {
      /* menu chinh cua chuong trinh                                        */
      printf("\n\t\tCAY NHI PHAN TIM KIEM CAN BANG (CAY AVL)");
      printf("\n\nCac chuc nang cua chuong trinh:\n");
      printf("   1: Them nut\n");
      printf("   2: Duyet cay theo thu tu truoc (NLR)\n");
      printf("   3: Duyet cay theo thu tu giua (LNR)\n");
      printf("   4: Duyet cay theo thu tu sau (LRN)\n");
      printf("   5: Tim kiem\n");
      printf("   0: Ket thuc chuong trinh\n");
      printf("Chuc nang ban chon: ");
      scanf("%d", &chucnang);
      switch(chucnang)
      {
	      case 1:
	      {
	         printf("noi dung nut moi: ");
	         scanf("%d", &noidung);
	         if(pavltree == NULL)                 /* Tao nut goc cua cay */
	            pavltree = makenode(noidung);
	         else
	            insert(&pavltree, noidung);
	         break;
	      }
	      case 2:
	      {
	         printf("\nDuyet cay theo thu tu truoc - NLR:\n");
	         pretrav(pavltree);
	         break;
	      }
	      case 3:
	      {
	         printf("\nDuyet cay theo thu tu giua - LNR:\n");
	         intrav(pavltree);
	         break;
	      }
	      case 4:
	      {
	         printf("\nDuyet cay theo thu tu sau - LRN:\n");
	         posttrav(pavltree);
	         break;
	      }
	      case 5:
	      {
	         printf("\nNoi dung can tim: ");
	         scanf("%d", &noidung);
	         if(search(pavltree, noidung))
	            printf("Tim thay");
	         else
	            printf("Khong tim thay");
	         break;
	      }
      }
   } while(chucnang != 0);
}