/*****************************************************************************
* Chuong trinh C7-2: Chuong trinh minh hoa Quick Sort                        *
* Nguoi viet chuong trinh: Nguyen Hong Chuong                                *
* Ngay cap nhat moi nhat: 15/3/1999                                          *
*****************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <conio.h>

#define MAXLIST 20000
#define TRUE 1
#define FALSE 0

// Khai bao danh sach ke chua cac nut can sap xep
int nodes[MAXLIST];

void partition(int nodes[], int low, int up, int *pivot)
{
   int nuttruc, l, u, temp;
   nuttruc = nodes[low];  // Chon phan tu dau lam truc
   l = low;
   u = up;
   while(l < u)
   {
      // quyet len
      while(nodes[l] <= nuttruc && l < up)
	      l++;

      // quyet xuong
      while(nodes[u] > nuttruc)
	      u--;

      if(l < u)
      {
	      // Doi cho hai phan tu tai hai vi tri down va up
	      temp = nodes[l];
	      nodes[l] = nodes[u];
	      nodes[u] = temp;
      }
   }
   // Doi cho phan tu truc va phan tu tai vi tri up
   nodes[low] = nodes[u];
   nodes[u] = nuttruc;
   *pivot = u;
}

void quicksort(int nodes[], int low, int up)
{
   int pivot;
   if(low >= up)                        // dieu kien dung
      return;
   if(low < up)                         // buoc de qui
   {
      partition(nodes, low, up, &pivot);
      quicksort(nodes, low, pivot-1);
      quicksort(nodes, pivot+1, up);
   }
}

// Chuong trinh chinh
void main()
{
   int chucnang;
   char c;

   clrscr();

   do
   {
      // menu chinh cua chuong trinh
      printf("\n\n\tQUICKSORT");
      printf("\n\nCac chuc nang cua chuong trinh:\n");
      printf("   1: Tao danh sach voi %d so ngau nhien\n", MAXLIST);
      printf("   2: Quick Sort\n");
      printf("   3: Duyet danh sach\n");
      printf("   0: Ket thuc chuong trinh\n");
      printf("Chuc nang ban chon: ");
      scanf("%d", &chucnang);
      switch(chucnang)
      {
	      case 1:
	      {
	         for(int i = 0; i < MAXLIST; i++)
	            nodes[i] = random(1000);
	         printf("\nDa tao xong danh sach voi %d so ngau nhien", MAXLIST);
	         break;
	      }
	      case 2:
	      {
	         quicksort(nodes, 0, MAXLIST-1);
	         printf("\nDa sap xep xong danh sach theo giai thuat Quick Sort");
	         break;
	      }
	      case 3:
	      {
	         printf("\nDUYET DANH SACH:\n");
	         for(int i = 0; i < MAXLIST; i++)
	            printf("%4d", nodes[i]);
	         break;
	      }
      }
   } while(chucnang != 0);
}