/*****************************************************************************
* Chuong trinh C7-3: Chuong trinh minh hoa Heap Sort                         *
* Nguoi viet chuong trinh: Nguyen Hong Chuong                                *
* Ngay cap nhat moi nhat: 15/3/1999                                          *
*****************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <conio.h>

#define MAXLIST 200
#define TRUE 1
#define FALSE 0

int nodes[MAXLIST];

void heapsort(int nodes[], int n)
{
   int k, x, s, f, ivalue;

   // chuyen danh sach nodes[] thanh heap
   for(k = 1; k < n; k++)
   {
      x = nodes[k]; // Nut can them vao heap

      // tac vu insert(nodes[], k, x)
      s = k;             // s la nut con
      f = (s-1)/2;       // f la nut cha
      while(s > 0 && nodes[f] < x)
      {
	      nodes[s] = nodes[f]; // keo nut < x xuong mot muc
	      s = f;
	      f = (s-1)/2;
      }
      nodes[s] = x;      // dien nut x vao vi tri phu hop
   }

   // lan luot xoa nodes[0] tren heap, copy no ve vi tri thich hop tren ds
   for(k = n-1; k > 0; k--)
   {
      // tac vu removeroot(nodes[], k+1)
      ivalue = nodes[k]; // ivalue la nut hien tai o vi tri k
      nodes[k] = nodes[0];    // chuyen nut goc xuong vi tri k

      f = 0;  // f la nut cha, s la nut con lon hon
      // s = largeson(0, k-1)
      if(k == 1)
	      s = -1;
      else
	      s = 1;
      if(k > 2 && nodes[2] > nodes[1])
	      s = 2;
      while(s >= 0 && ivalue < nodes[s])
      {
	      nodes[f] = nodes[s];  // doi nut con lon hon len 1 muc
	      f = s;

	      // s = largeson(f, k-1)
	      s = 2*f+1;
	      if(s+1 <= k-1 && nodes[s] < nodes[s+1])
	         s = s+1;
	      if(s > k-1)
	         s = -1;
      }
      nodes[f] = ivalue;
   }
}

// Chuong trinh chinh
void main()
{
   int i, chucnang;
   char c;

   clrscr();

   do
   {
      // menu chinh cua chuong trinh
      printf("\n\n\tHEAPSORT");
      printf("\n\nCac chuc nang cua chuong trinh:\n");
      printf("   1: Tao danh sach voi %d so ngau nhien\n", MAXLIST);
      printf("   2: Heap Sort\n");
      printf("   3: Duyet danh sach\n");
      printf("   0: Ket thuc chuong trinh\n");
      printf("Chuc nang ban chon: ");
      scanf("%d", &chucnang);
      switch(chucnang)
      {
	      case 1:
	      {
	         for(i = 0; i < MAXLIST; i++)
	            nodes[i] = random(1000);
	         printf("\nDa tao xong danh sach voi %d so ngau nhien", MAXLIST);
	         break;
	      }
	      case 2:
	      {
	         heapsort(nodes, MAXLIST);
	         printf("\nDa sap xep xong danh sach theo giai thuat Heap Sort");
	         break;
	      }
	      case 3:
	      {
	         printf("\nDUYET DANH SACH:\n");
	         for(i = 0; i < MAXLIST; i++)
	            printf("%4d", nodes[i]);
	         break;
	      }
      }
   } while(chucnang != 0);
}